%          Evolving Self-Organizing Map: ESOM training function
%================================================================================
%=  Function Name:        esom.m                                                =
%=  Algorithm Designer:   Da Deng                                               =
%=  Program Developer:    Qun Song                                              =
%=  Date:                 October, 2001                                         =
%================================================================================
%
%   Syntax:  [Results] = esom(InputData, Parameters)
%
%   Input arguments: 
%      InputData is a n*m matrix, n is the number of data points and m is the 
%      number of dimensions.
%      Parameters is a structure including the following fields
%        Parameters.errthr: error threshold, default = 0.1
%        Parameters.learnrate: learning rate, default = 0.03
%        Parameters.sigma: Gaussian function parameter, default = 0.5
%        
%   Output arguments:
%      Result.nodes{i}.w denote the i-th nodes and Results.nodes{i}.c denote
%      their connections.if Result.nodes{i}.c(:) inclues j elements,that means,
%      i-th node has j-1 connections,from c(1) to c(2), c(1) to c(3),..., c(1)
%      to c(j).
%
%   Example: 
%            data0 = rand(100,2);
%            [res] = esom(data0);
%
